'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _MeteorApp = require('./MeteorApp');

var _MeteorApp2 = _interopRequireDefault(_MeteorApp);

var _startPuppeteer = require('./startPuppeteer');

var _startPuppeteer2 = _interopRequireDefault(_startPuppeteer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (options) {
  var _ref = options || {},
      args = _ref.args,
      appDir = _ref.appDir,
      settings = _ref.settings,
      meteorPath = _ref.meteorPath,
      _ref$port = _ref.port,
      port = _ref$port === undefined ? 3000 : _ref$port,
      _ref$puppeteerOptions = _ref.puppeteerOptions,
      puppeteerOptions = _ref$puppeteerOptions === undefined ? {} : _ref$puppeteerOptions;

  if (!appDir) throw new Error('appDir not specified!');

  var meteorApp = new _MeteorApp2.default({
    args: args,
    appDir: appDir,
    port: port,
    settings: settings,
    meteorPath: meteorPath
  });

  return Promise.all([meteorApp.launch(), (0, _startPuppeteer2.default)(puppeteerOptions)]).then(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        meteor = _ref3[0],
        puppeteer = _ref3[1];

    puppeteer.meteor = meteorApp; // eslint-disable-line no-param-reassign
    puppeteer.on('close', function () {
      meteor.kill();
    });

    return puppeteer.goto('http://localhost:' + port).then(function () {
      return puppeteer;
    });
  });
};